sbit soft_i2c_scl           at RA5_bit;
sbit soft_i2c_sda           at RA3_bit;        // i2c (DS1307)
sbit soft_i2c_scl_direction at TRISA5_bit;
sbit soft_i2c_sda_direction at TRISA3_bit;

unsigned char dtd, dtu;
unsigned short ss, mm, hh, mm11, mm12, td, tu, mmb, hhb, pg, mmt, hht, ml;
unsigned short k, a, d1, d2, d3, d4, d5, j;
bit e, e1, e2, e3, e4, e5, e6, e7, e8, e9, bd1, bd2, tm, bd, sb, bt1;
unsigned t, mm1, t1;

/*  
hh-  ()
mm-  ()
ss-  ()
mm1-    
mm11, mm12-      EEPROM     
hhb-   ()
mmb-   ()
hht-   ()
mmt-   ()
td-    ()
tu-    ()
dtd-  ()
dtu-  ()
pg- ()
*/

/*
     .
 () - A2-RC6, A1-RC5, A0-RC4.
 () -
Y0-1 (A2-L, A1-L, A0-L), portc=0x04; 0000 0100
Y1-2 (A2-L, A1-L, A0-H), portc=0x14; 0001 0100
Y3-3 (A2-L, A1-H, A0-H), portc=0x34; 0011 0100  2 =1    
Y6-4 (A2-H, A1-H, A0-L), portc=0x64; 0110 0100
Y2-5 (A2-L, A1-H, A0-L). portc=0x24; 0010 0100
*/

void interrupt() //  (   tmr0)
{
ml++; tmr0=96; intcon=0x20; a++;

if (a==1) {portb=0xff; portc=0x04; portb=d1;} //1 

if (a==2) {portb=0xff; portc=0x14; portb=d2;} //2 

if (a==3) {portb=0xff; portc=0x34; portb=d3;} //3 

if (a==4) {portb=0xff; portc=0x64; portb=d4;} //4 

if (a==5) {portb=0xff; portc=0x24; portb=d5; a=0;} //5 

if (bd2==1) {portb=0xff; sound_play(700,1000); bd2=0;} //.    . 
}

char cif(char n) //     
{
switch (n)
{
 case 0:  return 0xC0;
 case 1:  return 0xF9;
 case 2:  return 0xA4;
 case 3:  return 0xB0;
 case 4:  return 0x99;
 case 5:  return 0x92;
 case 6:  return 0x82;
 case 7:  return 0xF8;
 case 8:  return 0x80;
 case 9:  return 0x90;
 case 10: return 0x40; //0.
 case 11: return 0x79; //1.
 case 12: return 0x24; //2.
 case 13: return 0x30; //3.
 case 14: return 0x19; //4.
 case 15: return 0x12; //5.
 case 16: return 0x02; //6.
 case 17: return 0x78; //7.
 case 18: return 0x00; //8.
 case 19: return 0x10; //9.
}
}

void temp()
{
ow_reset(&porta,2);
ow_write(&porta,2,0x33); // 
dtd=ow_read(&porta,2);

ow_reset(&porta,2);
ow_write(&porta,2,0xcc); //  
ow_write(&porta,2,0x44);
delay_us(120);                                      // 
ow_reset(&porta,2);
ow_write(&porta,2,0xcc); //    
ow_write(&porta,2,0xbe);

t=ow_read(&porta,2);     //  
t=(ow_read(&porta,2)*256)+t;  //  
td=t>>4; //   
}


void temp1()
{
ow_reset(&porta,0);
ow_write(&porta,0,0x33); // 
dtu=ow_read(&porta,0);

ow_reset(&porta,0);
ow_write(&porta,0,0xcc); //  
ow_write(&porta,0,0x44);
delay_us(120);                            //  
ow_reset(&porta,0);
ow_write(&porta,0,0xcc); //    
ow_write(&porta,0,0xbe);

t1=ow_read(&porta,0);     //  
t1=(ow_read(&porta,0)*256) + t1;  //  
if (t1 & 0x8000)
{
e7=1; t1=~t1+1; // 
}
else
{
e7=0;t1=t1; // 
}
tu=t1>>4;
}


void but()
{
if (k==0)
{
if (rc3_bit==1) e=1;  //   
if (e && rc3_bit==0)
{
if (mm1>0) {porta.b1=~porta.b1; tm=~tm;} e=0;
if (tm==1) // 
{
hht=mm1/60; //     
mmt=mm1-hht*60; //     
mmt=mm+mmt; if (mmt>59) {mmt=mmt-59; hht++;} //  . 
hht=hh+hht; if (hht>23) hht=hht-24; //  . 
}
}
}

if (k<6)
{if (rc1_bit==1) e1=1;
if (e1 && rc1_bit==0)  //   
{if (e4==0) {k=1; e1=0; e4=1;} else;{k++; if (k==5) {k=0;e4=0;} e1=0;}}}

if (k==0 || (k>5 && k<9))
{if (rc0_bit==1) e2=1;
if (e2 && rc0_bit==0)  //    
{if (e5==0) {k=6; e2=0; e5=1;} else; {k++; if (k==8) {k=0;e5=0;} e2=0;}}}

if (k==0 || (k>8 && k<13))
{if (rc7_bit==1) e3=1;
if (e3 && rc7_bit==0)  //     
{if (e6==0) {k=9; e3=0; e6=1;} else; {k++; if (k==12) {k=0;e6=0;bd1=bd2=0;} e3=0;}}}
}


void ust()
{
if (k==2) // 
{
if (rc3_bit==0)
{
hh++; if (hh>23) hh=0; hh=Dec2Bcd(hh);
soft_i2c_start();     //    DS1307
soft_i2c_write(0xd0); //   
soft_i2c_write(2);    //  
soft_i2c_write(hh);   // 
soft_i2c_stop();      // 
hh=Bcd2Dec(hh);
}
if (hh>9) {j=(hh/10);d1=cif(j);} else d1=0xff;
j=hh%10;d2=cif(j);
d3=d4=d5=0xff;
}

if (k==3) // 
{
if (rc3_bit==0)
{
mm++; if (mm>59) mm=0; mm=Dec2Bcd(mm);
soft_i2c_start();     //    DS1307
soft_i2c_write(0xd0); //   
soft_i2c_write(1);    //  
soft_i2c_write(mm);   // 
soft_i2c_stop();      // 
mm=Bcd2Dec(mm);
}
d1=d2=d3=0xff;
j=(mm/10)%10;d4=cif(j);
j=mm%10;d5=cif(j);
}

if (k==4) // 
{
if (rc3_bit==0)
{
soft_i2c_start();     //    DS1307
soft_i2c_write(0xd0); //   
soft_i2c_write(0);    //  
soft_i2c_write(0);    // 
soft_i2c_stop();      // 
}
j=(ss/10)%10;d1=cif(j);
j=ss%10;d2=cif(j);
d3=d4=d5=0xff;
}
}

void pod()
{
if (rc7_bit==0) {pg++; bt1=1;}
if (rc1_bit==0) {pg--; bt1=1;}
if (pg>30) pg=0;
d1=0x48; //.
d2=0xbf; //-
if (pg<10) {j=pg%10;d3=cif(j);d4=0xff;}
if (pg>9 && pg<100) {j=pg%10;d4=cif(j);j=(pg/10)%10;d3=cif(j);}
d5=0xff;
if (bt1==1) {eeprom_write(0,pg); bt1=0;} //       
}

void tim()
{
if (rc1_bit==0) {mm1=mm1+100; bt1=1;}
if (rc0_bit==0) {mm1=mm1+10;  bt1=1;}
if (rc3_bit==0) {mm1=mm1+1;   bt1=1;}
if (mm1>900) mm1=0;
d1=0x09;//H.
d2=0xbf;//-
if (mm1<10) {j=mm1%10;d3=cif(j); d4=d5=0xff;}
if (mm1>9 && mm1<100) {j=mm1%10;d4=cif(j);j=(mm1/10)%10;d3=cif(j);d5=0xff;}
if (mm1>99) {j=mm1%10;d5=cif(j);j=(mm1/10)%10;d4=cif(j);j=(mm1/100)%10;d3=cif(j);}
mm11=mm1>>8; //.  mm11=mm2/256;
mm12=mm1<<0; // mm12=mm2-256*mm11;
if (bt1==1) {eeprom_write(1,mm11); eeprom_write(2,mm12); bt1=0;} //       
}

void bud() //   
{
if (bd1==0 && bd2==0) {if (rc3_bit==0) {bd=~bd; eeprom_write(5,bd);}} //bd=1 -  ., bd=0 -  .
//       portc,7.
if (bd==1) // 
{
if (bd1==0 && bd2==0) //   
{
if (rc1_bit==0) {hhb++; if (hhb>23) hhb=0; eeprom_write(3,hhb);}
if (rc0_bit==0) {mmb++; if (mmb>59) mmb=0; eeprom_write(4,mmb);}
}

if (hhb>9) {j=(hhb/10);d1=cif(j+10);} else d1=0xff; //(j+10)   ,  j=15 - 5.
j=hhb%10;d2=cif(j+10);
d3=0x3f; //-.
j=(mmb/10)%10;d4=cif(j+10);
j=mmb%10;d5=cif(j+10);
if (bd1==1) // 
{
if (mmb!=59 && mmb<mm) {bd1=0; bd2=0; k=0; e6=0;}  //        
if (mmb==59 && mm==0) {bd1=0; bd2=0; k=0; e6=0;}  //     () =59;
bd2=~bd2; //bd=1>>>bd1=1>>>bd2=1>>>.   
}
}
else
{
d1=d2=d3=d4=d5=0x3f; // 
}
}


void main()
{
  adcon1=6; //  
  porta=0x02; trisa=0xfd;
  portb=0xff; trisb=0x00;
  portc=0xdf; trisc=0x8b;
  option_reg=0x84; // 1/32
  tmr0=96; //  160
  intcon=0xa0; ml=0;
  soft_i2c_init(); // i2c (DS1307)
  sound_init(&portc,2); //   RC2

  k=e4=e5=e6=mm=ss=hh=a=j=bd1=bd2=tm=sb=bt1=0; d1=d2=d3=d4=d5=0xff; dtd=dtu=0;
  pg=eeprom_read(0);  //      (  15)
  mm11=eeprom_read(1); //mm11, m12 - 8     16    EEPROM   8  
  mm12=eeprom_read(2);
  mm1=mm11*256+mm12;   //mm1=(mm11<<8)+mm12;    
  hhb=eeprom_read(3);  //      ()
  mmb=eeprom_read(4);  //      ()
  bd=eeprom_read(5);  //   / 
do
{
if (ml==200) //    0,5 
{
ml=0;
    soft_i2c_start();     //    DS1307
    soft_i2c_write(0xd0); //   
    soft_i2c_write(0);    //    
    soft_i2c_start();     //  
    soft_i2c_write(0xd1); //   
    ss=soft_i2c_read(1);  //  (  - )
    mm=soft_i2c_read(1);  //  - 
    hh=soft_i2c_read(0);  //  ( (   )  - )
    soft_i2c_stop();      //    DS1307
    ss=Bcd2Dec(ss);  //Bcd2Dec -     
    mm=Bcd2Dec(mm);
    hh=Bcd2Dec(hh);

    if (hh!=0) sb=0; //sb-  .  

    if (sb==0 && hh==0 && mm==0 && ss==15 && pg!=15) //  ()    (0:00:15)
    {
    ss=ss+pg-15; //  / 
    ss=Dec2Bcd(ss);
    soft_i2c_start();     //    DS1307
    soft_i2c_write(0xd0); //   
    soft_i2c_write(0);   //  
    soft_i2c_write(ss);   // 
    soft_i2c_stop();      // 
    ss=Bcd2Dec(ss);
    sb=1;
    }

    but(); //   

    if (k==0) //  
    {
    if ((ss<10) || (ss>19 && ss<30) || (ss>39 && ss<50)) // 
    {
    if (hh>9) {j=(hh/10);d1=cif(j);} else d1=0xff;
    j=hh%10;d2=cif(j);
    d3=0xbf;
    j=(mm/10)%10;d4=cif(j);
    if (bd==0) {j=mm%10;d5=cif(j);} else {j=mm%10;d5=cif(j+10);} // . .,      
    }

    if ((ss>9 && ss<15) ||  (ss>29 && ss<35) || (ss>49 && ss<55)) //  
    {
    temp();
    if (dtd==0x28) //   
    {
    if (td>9 && td<41) e8=0; else e8=1; //  ( 10  40 )
    d5=0xc6; //C
    d4=0x9c; // 
    if (e8==0)
    {j=td%10;d3=cif(j); j=(td/10)%10;d2=cif(j);}
    else
    {d3=0xbf;d2=0xbf;} d1=0xff;}
    else
    {d5=0xc6;d4=0x9c;d3=0xbf;d2=0xbf;d1=0xff;}
    }

    if ((ss>14 && ss<20) || (ss>34 && ss<40) || (ss>54 && ss<60)) //   
    {
    temp1();
    if (dtu==0x28)
    {
    if (tu>40) e9=1; else e9=0; //  ( -40  40 )
    d5=0x46; //C.
    d4=0x9c;
    if (e9==0)
    {
    j=tu%10;d3=cif(j);
    if (tu>9) {j=(tu/10)%10;d2=cif(j);
    if (e7==0) d1=0xff; else d1=0xbf;} //   (e7)

    if (tu>0 && tu<10) {d1=0xff;
    if (e7==0) d2=0xff; else d2=0xbf;} //   (e7)

    if (tu==0) d1=d2=0xff;
    }
    else
    {
    d3=0xbf;d2=0xbf;d1=0xff;
    }
    }
    else
    {
    d5=0x46;d4=0x9c;d3=0xbf;d2=0xbf;d1=0xff;
    }
    }
    }

    if (k>1 && k<5) ust(); // 
    if (k==7)  pod();      //  
    if (k==10) tim();      // 
    if (k==11) bud();      // 

    if (bd==1 && hhb==hh && mmb==mm && ss==0 && k==0) {k=11; bd1=1; bd2=0; e6=1;} // 
    if (tm==1 && hht==hh && mmt==mm && ss==0 || mm1==0) {porta.b1=1; tm=0;} // 
}
}while(1);
}